package org.jeecg;

import cn.com.ctop.common.module.entity.BindAccountLogin;
import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.IBindAccountLoginService;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.CorpWexinUtils;
import cn.com.ctop.common.module.utils.CtopAdConstant;
import cn.com.ctop.crawler.modules.pangolin.entity.PangolinApp;
import cn.com.ctop.crawler.modules.pangolin.service.PangolinAppService;
import cn.com.ctop.crawler.modules.pangolin.service.PangolinCrawlerService;
import cn.com.ctop.crawler.modules.pangolin.service.PangolinLoginService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouInterfaceService;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouWebInterfaceService;
import cn.com.ctop.toutiao.modules.material.service.IByteDanceAdvertiserDataService;
import cn.com.ctop.toutiao.modules.material.service.IByteDanceCampaignService;
import cn.com.ctop.toutiao.modules.material.vo.BytedanceCampaignEditVo;
import cn.com.ctop.toutiao.modules.report.service.IReportService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import me.chanjar.weixin.common.error.WxErrorException;
import me.chanjar.weixin.cp.bean.WxCpMessage;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.ctop.entity.KuaishouEffectVideoInfo;
import org.jeecg.modules.ctop.service.IKuaishouEffectVideoInfoService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.HashMap;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import me.chanjar.weixin.common.error.WxErrorException;
import me.chanjar.weixin.cp.api.WxCpService;
import me.chanjar.weixin.cp.api.impl.WxCpServiceImpl;
import me.chanjar.weixin.cp.bean.WxCpMessage;
import me.chanjar.weixin.cp.config.impl.WxCpDefaultConfigImpl;

@RunWith(SpringRunner.class)
@SpringBootTest
@Slf4j
public class SampleTest {
    @Autowired
    private ICtopOauthTokenService oauthTokenService;
    @Autowired
    private IByteDanceAdvertiserDataService advertiserDataService;
    @Autowired
    private IReportService reportService;
    @Autowired
    private IKuaishouInterfaceService interfaceService;

    @Test
    public void loadBytedanceCampaignData() {


       // CorpWexinUtils.sendMessageByWeChatId("34585ddd4bd86e57756cf6a51b9443a5","测试消息发送");
        interfaceService.getAppList(23212L,"493aedfee07d9c500c50077e7c808145");



    }

    @Autowired
    private IBindAccountLoginService bindAccountLoginService;
    @Autowired
    private IKuaishouWebInterfaceService kuaishouWebInterfaceService;

    @Test
    public void kuaishouLogin() {
        Long start = System.currentTimeMillis();
        List<BindAccountLogin> list = bindAccountLoginService.getListByParams(CtopAdConstant.PLATFORM_TYPE_KUAISHOU_PY, 1);
        if (list != null && !list.isEmpty()) {
            for (BindAccountLogin login : list) {
                if (null == login.getCookie() || "".equals(login.getCookie().trim())) {
                    kuaishouWebInterfaceService.getkuaishouWebLoginCookie(login);
                }
            }
        }
        Long end = System.currentTimeMillis();
        log.info("总用时：{}毫秒", end - start);
    }

    static ExecutorService executorService = Executors.newFixedThreadPool(10);;
    static CountDownLatch countDownLatch = null;

    @Test
    public void kuaishouCommentDelete() {
        Long start = System.currentTimeMillis();
        List<BindAccountLogin> list = bindAccountLoginService.getListByParams(CtopAdConstant.PLATFORM_TYPE_KUAISHOU_PY, 1);
        if (list != null && !list.isEmpty()) {
            countDownLatch = new CountDownLatch(list.size());
            list.forEach(login -> {
                executorService.submit(() -> {
                    try {
                        if (null != login.getCookie() && !"".equals(login.getCookie().trim())) {
                            kuaishouWebInterfaceService.deleteAllComment(new HashMap<>(), login);
                        }
                    } catch (Exception e) {

                    } finally {
                        countDownLatch.countDown();
                    }
                });
            });
        }
        try {
            countDownLatch.await();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        Long end = System.currentTimeMillis();
        log.info("总用时：{}毫秒", end - start);
    }

    @Autowired
    private PangolinLoginService pangolinLoginService;
    @Autowired
    private PangolinCrawlerService pangolinCrawlerService;
    @Autowired
    private PangolinAppService pangolinAppService;

    @Test
    public void testPangolinLogin() {
        QueryWrapper<BindAccountLogin> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("login_type", "pangolin");
        queryWrapper.eq("status", 1);
        List<BindAccountLogin> list = bindAccountLoginService.list(queryWrapper);
        if (list != null && !list.isEmpty()) {
            for (BindAccountLogin login : list) {
                if (null == login.getCookie() || "".equals(login.getCookie().trim())) {
                    pangolinLoginService.pangolinLogin(login.getAccountName(), login.getPassword());
                }
            }
        }
    }

    @Test
    public void testPangolinData() {
        QueryWrapper<BindAccountLogin> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("login_type", "pangolin");
        queryWrapper.eq("status", 1);
        queryWrapper.isNotNull("cookie");
        List<BindAccountLogin> list = bindAccountLoginService.list(queryWrapper);
        if (list != null && !list.isEmpty()) {
            for (BindAccountLogin bindAccountLogin : list) {
                pangolinCrawlerService.getChannelList(bindAccountLogin);
                pangolinCrawlerService.getActivationList(bindAccountLogin, DateUtils.getNowDate("yyyy-MM-dd"), 1);
                pangolinCrawlerService.getCheckList(bindAccountLogin);
                QueryWrapper<PangolinApp> queryWrapper1 = new QueryWrapper<>();
                queryWrapper1.eq("account_name", bindAccountLogin.getAccountName());
                List<PangolinApp> appList = pangolinAppService.list(queryWrapper1);
                if (appList != null && !appList.isEmpty()) {
                    appList.forEach(pangolinApp -> pangolinCrawlerService.getRealTimeList(bindAccountLogin, pangolinApp.getAppId()));
                }
            }
        }
    }
    @Autowired
    private IByteDanceCampaignService campaignService;
    @Test
    public void testGetCampaign(){
        CtopOauthToken token = oauthTokenService.getOauthTokenByAccountId("1649600126891015");
        campaignService.getAdvertiserCampaign(token,"1672261893872756",null);
    }

    @Autowired
    private IKuaishouEffectVideoInfoService effectVideoInfoService;
    @Test
    public void loadKuaishouEffectVideoInfo(){
        List<KuaishouEffectVideoInfo>videoInfos = effectVideoInfoService.list();
        for (KuaishouEffectVideoInfo video:videoInfos) {
            if(null!=video.getSignature()&&!"".equals(video.getSignature())){
//                effectVideoInfoService.updateFinalCostDateBySignature(video.getSignature());
//                effectVideoInfoService.updateInitialCostDateBySignature(video.getSignature());
//                effectVideoInfoService.updateTotalCostBySignature(video.getSignature());
                if(null==video.getTwoWeekCost()){
                    effectVideoInfoService.updateTowWeekCostBySignature(video.getSignature());
                }
            }
        }
    }
}


















